﻿Imports System.Runtime.CompilerServices
Imports System.Data.Common
Imports System.Reflection
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Text.RegularExpressions

Namespace System.Data

   Public Module DatasetX
      ''' <summary>
      ''' get the manager of all Tables, TableAdapters and BindingSources and stuff
      ''' </summary>
      <DebuggerStepThrough()> _
      <Extension()> _
      Friend Function Attach(ByVal dts As DataSet) As DatasetAdapter
         Return DirectCast(DatasetAdapterBase.Attachs(dts), DatasetAdapter)
      End Function

      ''' <summary>gets the with table associated TableAdapter</summary>
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function InnerAdapter(ByVal tb As DataTable) As DbDataAdapter
         Return tb.DataSet.Attach.Adapters(tb).Adapter
      End Function

      ''' <summary>gets the with table associated TableAdapter</summary>
      <DebuggerStepThrough()> _
      <Extension()> _
      Friend Function Adapter(ByVal tb As DataTable) As TableAdapter
         Return tb.DataSet.Attach.Adapters(tb)
      End Function
      ''' <summary>
      ''' set the connection, for communication between dataset and database
      ''' </summary>
      <Extension()> _
      Public Function Adapter(ByVal dts As DataSet, ByVal value As DatasetAdapter) As DataSet
         value.DataSet = dts
         DatasetAdapterBase.Attachs(dts) = value
         Return dts
      End Function

      ''' <summary>the connection, for communication: dataset - database</summary>
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function Connection(ByVal dts As DataSet) As DbConnection
         Return dts.Attach.Connection
      End Function
      ''' <summary>clear dataset and refill. optional only the given tables</summary>
      <Extension()> _
      Public Sub Fill(ByVal dts As DataSet, ByVal ParamArray tables() As DataTable)
         dts.Clear()
         If tables.Length = 0 Then tables = dts.Tables.ToArray(Of DataTable)()
         With dts.Attach
            .AddFillJobs(From tb In tables Select New TableAdapter.FillJob(.Adapters(tb)))
         End With
      End Sub
      ''' <summary>fills the table, applying additional conditions</summary>
      <Extension()> _
      Public Sub Fill(ByVal tb As DataTable)
         tb.Fill("")
      End Sub
      ''' <summary>fills the table, applying additional conditions</summary>
      <Extension()> _
      Public Sub Fill(ByVal tb As DataTable, ByVal conditions As String, ByVal ParamArray values As Object())
         With tb.DataSet.Attach
            .AddFillJobs({.Adapters(tb).Fill(conditions, values, True, False)})
         End With
      End Sub
      ''' <summary>
      ''' fills child- and  child-child-tables of parentRow, applying additional
      ''' sql, eg. filter-clauses and stuff 
      ''' </summary>
      <Extension()> _
      Public Sub FillChildTables(ByVal parentRow As DataRow, ByVal tables As DataTable(), ByVal conditions As String, ByVal ParamArray values() As Object)
         With parentRow.Table.DataSet.Attach
            .AddFillJobs(From tb In tables _
               Select .Adapters(tb).FillByParentRow(parentRow, conditions, values))
         End With
      End Sub
      ''' <summary>
      ''' fills the childTables of parentRow with associated records. also supports
      ''' filling child-child-tables
      ''' </summary>
      <Extension()> _
      Public Sub FillChildTables(ByVal parentRow As DataRow, ByVal ParamArray tables As DataTable())
         FillChildTables(parentRow, tables, "", New Object() {})
      End Sub
      ''' <summary>
      ''' fills a childTable of parentRow, applying additionalsql, eg. filter-clauses</summary>
      <Extension()> _
      Public Sub FillChildTable(ByVal parentRow As DataRow, ByVal table As DataTable, ByVal conditions As String, ByVal ParamArray values() As Object)
         FillChildTables(parentRow, {table}, conditions, values)
      End Sub

   End Module

End Namespace
