﻿Imports System.Runtime.CompilerServices
Imports System.Windows.Forms
Imports System.Collections.Generic

Namespace System.Data

   Public Module modTableEventEnabler

      <Extension()> _
      Public Function Events(ByVal subj As DataTable) As TableEventEnabler
         Dim ret As TableEventEnabler = Nothing
         If Not TableEventEnabler.Enablers.TryGetValue(subj, ret) Then
            ret = New TableEventEnabler(subj)
            TableEventEnabler.Enablers.Add(subj, ret)
            AddHandler subj.Disposed, AddressOf Table_Disposed
         End If
         Return ret
      End Function

      Private Sub Table_Disposed(ByVal sender As Object, ByVal e As EventArgs)
         Dim tb = DirectCast(sender, DataTable)
         TableEventEnabler.Enablers(tb).Dispose()
         TableEventEnabler.Enablers.Remove(tb)
      End Sub

      <Extension()> _
      Public Sub SubscribeEventDisabling(ByVal subj As BindingSource)
         subj.DataTable.Events.AddSource(subj)
      End Sub

   End Module

   Public Class TableEventEnabler : Implements IDisposable

      Public Shared ReadOnly Enablers As New Dictionary(Of DataTable, TableEventEnabler)

      Private _Table As DataTable
      Public BindingSources As New List(Of BindingSource)
      Private _Level As Integer

      Public Sub New(ByVal tb As DataTable)
         _Table = tb
      End Sub

      Public Sub AddSource(ByVal bs As BindingSource)
         If BindingSources.Contains(bs) Then Throw Me.Exception( _
            "Die BindingSource mit DataMember '", bs.DataMember, _
            "' ist bereits fürs EventDisabling registriert")
         BindingSources.Add(bs)
         AddHandler bs.Disposed, AddressOf BindingSource_Disposed
      End Sub

      Private Sub BindingSource_Disposed(ByVal sender As Object, ByVal e As EventArgs)
         BindingSources.Remove(DirectCast(sender, BindingSource))
      End Sub

      Public Function Enable() As Boolean
         Return _Level = 0
      End Function
      Public Function Enable(ByVal value As Boolean, Optional ByVal resetBindings As Boolean = True) As TableEventEnabler
         If value Then
            _Level -= 1
            If _Level = 0 Then
               _Table.EndLoadData()
               For Each bs In BindingSources
                  bs.RaiseListChangedEvents = True
                  If resetBindings Then bs.ResetBindings(False)
               Next
            End If
         Else
            _Level += 1
            If _Level = 1 Then
               For Each bs In BindingSources
                  bs.RaiseListChangedEvents = False
               Next
               _Table.BeginLoadData()
            End If
         End If
         Return Me
      End Function

      Protected Overridable Sub Dispose(ByVal disposing As Boolean)
         If Not disposing Then Return
         If BindingSources Is Nothing Then Return
         For Each bs In BindingSources
            RemoveHandler bs.Disposed, AddressOf BindingSource_Disposed
         Next
         BindingSources = Nothing
         _Table = Nothing
      End Sub

      Public Sub Dispose() Implements IDisposable.Dispose
         Dispose(True)
         GC.SuppressFinalize(Me)
      End Sub

   End Class

End Namespace
