Imports Microsoft.VisualBasic
Imports System
Imports System.Drawing
Imports System.ComponentModel

Namespace System.Windows.Forms
   ''' <summary>beschriftetes Panel. Die Beschriftung wird im Padding-Bereich plaziert</summary>
   <Obsolete("better use CaptionPanel")> _
   <ToolboxItem(False)> _
   Public Class CaptionedPanel : Inherits Panel

#Region "Vars"
      Private _CaptionFont As Font = Nothing
      Private _CaptionColor As Color = Color.Black
      Protected _CaptionStringFormat As New StringFormat
      Protected Const _DefaultCaptionHeight As Integer = 16
      Protected Brsh As SolidBrush = New SolidBrush(_CaptionColor)
#End Region 'Vars

#Region "Initiation"
      Public Sub New()
         MyBase.new()
         With _CaptionStringFormat
            .Alignment = StringAlignment.Center
            .LineAlignment = StringAlignment.Near
            .FormatFlags = StringFormatFlags.NoWrap
            .Trimming = StringTrimming.EllipsisCharacter
         End With
         MyBase.Padding = New Padding(0, _DefaultCaptionHeight, 0, 0)
      End Sub

      Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
         _CaptionStringFormat.DisposeManaged(disposing).AndAlso(_CaptionFont, Brsh, components)
         MyBase.Dispose(disposing)
      End Sub

      'Fr Windows Form-Designer erforderlich
      Private components As System.ComponentModel.IContainer

#End Region 'Initiation

#Region "PublicMembers"

      <TypeConverter(GetType(ExpandableObjectConverter))> _
      <Browsable(True)> _
      <Category("Darstellung")> _
      <Description("Einige interessante Einstellmglichkeiten der Schrift-Darstellung")> _
      <DesignerSerializationVisibility(DesignerSerializationVisibility.Content)> _
      Public ReadOnly Property CaptionStringFormat() As StringFormat
         Get
            If MyDesignMode.True Then Invalidate(False)
            Return _CaptionStringFormat
         End Get
      End Property

      <Category("Darstellung")> _
      Public Property CaptionFont() As Font
         Get
            If _CaptionFont Is Nothing Then _CaptionFont = New Font(MyBase.Font, FontStyle.Regular)
            Return _CaptionFont
         End Get
         Set(ByVal NewValue As Font)
            If Object.Equals(NewValue, _CaptionFont) Then Return
            If _CaptionFont IsNot Nothing Then _CaptionFont.Dispose()
            _CaptionFont = NewValue
            Invalidate()
         End Set
      End Property
      <Category("Darstellung")> _
      <Browsable(True)> _
      Public Property CaptionColor() As Color
         Get
            Return _CaptionColor
         End Get
         Set(ByVal NewValue As Color)
            If Object.Equals(NewValue, Me.CaptionColor) Then Return
            _CaptionColor = NewValue
            Invalidate()
         End Set
      End Property

      <Browsable(True)> _
      <Category("Darstellung")> _
      Public Overrides Property Text() As String
         Get
            Return MyBase.Text
         End Get
         Set(ByVal value As String)
            MyBase.Text = value
            Invalidate()
         End Set
      End Property

#Region "PublicMembers.PropertiesVormDesignerVerbergen"
      'Ich finde, das erhht die Usability erheblich, wenn's Eigenschaftenfenster nicht zu voll ist

      <Browsable(False)> _
      Public Overrides Property AutoSizeMode() As AutoSizeMode
         Get
            Return MyBase.AutoSizeMode
         End Get
         Set(ByVal NewValue As AutoSizeMode)
            MyBase.AutoSizeMode = NewValue
         End Set
      End Property

      <Browsable(False)> _
      Public Overrides Property AutoSize() As Boolean
         Get
            Return MyBase.AutoSize
         End Get
         Set(ByVal NewValue As Boolean)
            MyBase.AutoSize = NewValue
         End Set
      End Property

      <Browsable(False)> _
      Public Shadows Property AutoScrollMinSize() As Size
         Get
            Return MyBase.AutoScrollMinSize
         End Get
         Set(ByVal NewValue As Size)
            MyBase.AutoScrollMinSize = NewValue
         End Set
      End Property

      <Browsable(False)> _
      Public Shadows Property AutoScrollMargin() As Size
         Get
            Return MyBase.AutoScrollMargin
         End Get
         Set(ByVal NewValue As Size)
            MyBase.AutoScrollMargin = NewValue
         End Set
      End Property

      <Browsable(False)> _
      Public Overrides Property AutoScroll() As Boolean
         Get
            Return MyBase.AutoScroll
         End Get
         Set(ByVal NewValue As Boolean)
            MyBase.AutoScroll = NewValue
         End Set
      End Property

      <Browsable(False)> _
      Public Overrides Property BackGroundImageLayout() As ImageLayout
         Get
            Return MyBase.BackgroundImageLayout
         End Get
         Set(ByVal NewValue As ImageLayout)
            MyBase.BackgroundImageLayout = NewValue
         End Set
      End Property

      <Browsable(False)> _
      Public Overrides Property BackGroundImage() As Image
         Get
            Return MyBase.BackgroundImage
         End Get
         Set(ByVal NewValue As Image)
            MyBase.BackgroundImage = NewValue
         End Set
      End Property

      <Browsable(False)> _
      Public Overrides Property Cursor() As System.Windows.Forms.Cursor
         Get
            Return MyBase.Cursor
         End Get
         Set(ByVal Value As System.Windows.Forms.Cursor)
            MyBase.Cursor = Value
         End Set
      End Property

      <Browsable(False)> _
      Public Overrides Property Anchor() As System.Windows.Forms.AnchorStyles
         'Anchor verbergen (SizeablePanel ist auf Docking ausgelegt)
         Get
            Return AnchorStyles.None
         End Get
         Set(ByVal Value As System.Windows.Forms.AnchorStyles)

         End Set
      End Property
#End Region 'PublicMembers.PropertiesVormDesignerVerbergen
#End Region 'PublicMembers

#Region "ProcessingEvents"

      Protected Overrides Sub OnSizeChanged(ByVal e As System.EventArgs)
         MyBase.OnSizeChanged(e)
         If _CaptionStringFormat.LineAlignment = StringAlignment.Center OrElse _
            MyBase.Text = "" Then Return
         MyBase.Invalidate(False) 'Neuzeichnung meiner Caption gewhrleisten
      End Sub

      Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
         MyBase.OnPaint(e)
         If MyDesignMode.False AndAlso _
            (_CaptionStringFormat.LineAlignment = StringAlignment.Center OrElse MyBase.Text = "") _
            Then Return
         If Brsh.Color.ToArgb <> _CaptionColor.ToArgb Then Brsh.Color = _CaptionColor
         e.Graphics.DrawString(MyBase.Text, Me.CaptionFont, Brsh, Me.ClientRectangle, _CaptionStringFormat)
      End Sub

#End Region 'ProcessingEvents

   End Class

End Namespace